dnl
dnl Initialize an autoconf project that use Open BEAGLE.
dnl
dnl  by Christian Gagne, 14/10/2002
dnl
dnl OB_BEAGLE_INIT(BEAGLE_PATH
dnl                [, BEAGLE_INCLUDEPATH]
dnl                [, BEAGLE_LIBPATH]
dnl                [, BEAGLE_GA_INCLUDEPATH]
dnl                [, BEAGLE_GA_LIBPATH]
dnl                [, BEAGLE_GP_INCLUDEPATH]
dnl                [, BEAGLE_GP_LIBPATH])
dnl
AC_DEFUN([OB_BEAGLE_INIT],
[

dnl Open BEAGLE optimization mode option.
AC_ARG_ENABLE(optimization,
  [  --enable-optimization    enable optimization mode [default=no]],
  [case $enableval in
  yes) enable_optimization=yes;;
  no) enable_optimization=no;;
  *) enable_optimization=no;; esac],
  enable_optimization=no)
if test "$enable_optimization" = yes; then
  CFLAGS=`echo $CFLAGS | sed 's/\(?*\)-g\(?*\)/\1\2/'`
  CXXFLAGS=`echo $CXXFLAGS | sed 's/\(?*\)-g\(?*\)/\1\2/'`
else
  CFLAGS=`echo $CFLAGS | sed 's/\(?*\)-O[[0-9]]\(?*\)/\1\2/'`
  CXXFLAGS=`echo $CXXFLAGS | sed 's/\(?*\)-O[[0-9]]\(?*\)/\1\2/'`
fi

dnl Set headers and libraries path correctly
AC_ARG_WITH(beagle,
  [  --with-beagle=DIR       specify installation path of Open BEAGLE],
  [ob_beagle_path="$withval"],
  [ob_beagle_path="$1"])
AC_ARG_WITH(beagle-include,
  [  --with-beagle-include=DIR specify exact dir for Open BEAGLE headers],
  [ob_beagle_path_include="$withval"])
AC_ARG_WITH(beagle-GA-include,
  [  --with-beagle-GA-include=DIR specify exact dir for Open BEAGLE GA headers],
  [ob_beagle_path_ga_include="$withval"])
AC_ARG_WITH(beagle-GP-include,
  [  --with-beagle-GP-include=DIR specify exact dir for Open BEAGLE GP headers],
  [ob_beagle_path_gp_include="$withval"])
AC_ARG_WITH(beagle-libdir,
  [  --with-beagle-libdir=DIR specify exact dir for Open BEAGLE libraries],
  [ob_beagle_path_lib="$withval"])
AC_ARG_WITH(beagle-GA-libdir,
  [  --with-beagle-GA-libdir=DIR specify exact dir for Open BEAGLE GA libraries],
  [ob_beagle_path_ga_lib="$withval"])
AC_ARG_WITH(beagle-GP-libdir,
  [  --with-beagle-GP-libdir=DIR specify exact dir for Open BEAGLE GP libraries],
  [ob_beagle_path_gp_lib="$withval"])
if test -z "$ob_beagle_path"; then
  ob_beagle_path="$1"
fi
if test -z "$ob_beagle_path_include"; then
  if test -z "$2"; then
    ob_beagle_path_include="$ob_beagle_path"/include
  else
    ob_beagle_path_include="$2"
  fi
fi
if test -z "$ob_beagle_path_libdir"; then
  if test -z "$3"; then
    ob_beagle_path_libdir="$ob_beagle_path"/lib
  else
    ob_beagle_path_libdir="$3"
  fi
fi
if test -z "$ob_beagle_path_ga_include"; then
  if test -z "$4"; then
    ob_beagle_path_ga_include=$ob_beagle_path_include
  else
    ob_beagle_path_ga_include="$4"
  fi
fi
if test -z "$ob_beagle_path_ga_libdir"; then
  if test -z "$5"; then
    ob_beagle_path_ga_libdir=$ob_beagle_path_libdir
  else
    ob_beagle_path_ga_libdir="$5"
  fi
fi
if test -z "$ob_beagle_path_gp_include"; then
  if test -z "$6"; then
    ob_beagle_path_gp_include=$ob_beagle_path_include
  else
    ob_beagle_path_gp_include="$6"
  fi
fi
if test -z "$ob_beagle_path_gp_libdir"; then
  if test -z "$7"; then
    ob_beagle_path_gp_libdir=$ob_beagle_path_libdir
  else
    ob_beagle_path_gp_libdir="$7"
  fi
fi
CPPFLAGS="$CPPFLAGS -I$ob_beagle_path_include -I$ob_beagle_path_ga_include -I$ob_beagle_path_gp_include"
CFLAGS="$CFLAGS -I$ob_beagle_path_include -I$ob_beagle_path_ga_include -I$ob_beagle_path_gp_include"
LIBS="$LIBS $ob_beagle_path_gp_libdir/libbeagle-GP.la $ob_beagle_path_ga_libdir/libbeagle-GA.la $ob_beagle_path_libdir/libbeagle.la"
dnl Finally, do a little compilation test.
AC_CACHE_CHECK(if Open BEAGLE headers are correctly included,
ob_beagle_include_test,
[AC_LANG_SAVE
 AC_LANG_CPLUSPLUS
 AC_TRY_CPP([beagle/beagle.hpp beagle/GA.hpp beagle/GP.hpp],
            ob_beagle_include_test=yes,
            ob_beagle_include_test=no)
 AC_LANG_RESTORE
])
])

AC_DEFUN([CHECK_ZLIB],
#
# Handle user hints
#
[AC_MSG_CHECKING(if zlib is wanted)
AC_ARG_WITH(zlib,
[  --with-zlib=DIR root directory path of zlib installation [defaults to
                    /usr/local or /usr if not found in /usr/local]
  --without-zlib to disable zlib usage completely],
[if test "$withval" != no ; then
  AC_MSG_RESULT(yes)
  ZLIB_HOME="$withval"
else
  AC_MSG_RESULT(no)
fi], [
AC_MSG_RESULT(yes)
ZLIB_HOME=/usr/local
if test ! -f "${ZLIB_HOME}/include/zlib.h"
then
        ZLIB_HOME=/usr
fi
])
#
# Locate zlib, if wanted
#
if test -n "${ZLIB_HOME}"
then
        ZLIB_OLD_LDFLAGS=$LDFLAGS
        ZLIB_OLD_CPPFLAGS=$LDFLAGS
        LDFLAGS="$LDFLAGS -L${ZLIB_HOME}/lib"
        CPPFLAGS="$CPPFLAGS -I${ZLIB_HOME}/include"
        AC_LANG_SAVE
        AC_LANG_C
        AC_CHECK_LIB(z, inflateEnd, [zlib_cv_libz=yes], [zlib_cv_libz=no])
        AC_CHECK_HEADER(zlib.h, [zlib_cv_zlib_h=yes], [zlib_cv_zlib_h=no])
        AC_LANG_RESTORE
        if test "$zlib_cv_libz" = "yes" -a "$zlib_cv_zlib_h" = "yes"
        then
                #
                # If both library and header were found, use them
                #
                AC_CHECK_LIB(z, inflateEnd)
                AC_MSG_CHECKING(zlib in ${ZLIB_HOME})
                AC_MSG_RESULT(ok)
        else
                #
                # If either header or library was not found, revert and bomb
                #
                AC_MSG_CHECKING(zlib in ${ZLIB_HOME})
                LDFLAGS="$ZLIB_OLD_LDFLAGS"
                CPPFLAGS="$ZLIB_OLD_CPPFLAGS"
                AC_MSG_RESULT(failed)
                AC_MSG_ERROR(either specify a valid zlib installation with --with-zlib=DIR or disable zlib usage with --without-zlib)
        fi
fi
])
